IF EXISTS 
( 
    SELECT * FROM sys.objects 
    WHERE object_id = object_id ( N'[dbo].[calendar]' ) 
    AND type IN ( N'P' , N'PC' ) 
) 
DROP PROCEDURE [dbo].[calendar] 
GO 

/***************************************************************************************
Created By :- Vinay Kumar
Created on :- 29 Jan 2008
Purpose :- Print the calendar from the given Date

Modified On :- July 20, 2012


--- EXEC calendar '02/11/2011'
****************************************************************************************/ 

CREATE PROCEDURE calendar 
@StartDate datetime = '01/01/2012' ----Default Value
AS 
SET NOCOUNT ON 

DECLARE @tbl TABLE 
( RowID int IDENTITY ( 1 , 1 ) , Sun varchar ( 20 ) DEFAULT '' , Mon varchar ( 20 ) DEFAULT '' , Tue varchar ( 20 ) DEFAULT '' , 
    Wed varchar ( 20 ) DEFAULT '' , Thu varchar ( 20 ) DEFAULT '' , Fri varchar ( 20 ) DEFAULT '' , Sat varchar ( 20 ) DEFAULT '' ) 

DECLARE @currentMonth int 
DECLARE @CurrentDate int 
DECLARE @CurrentDay int 
DECLARE @CurrentRowID int 
DECLARE @TotalMonthDays int 
DECLARE @monthName varchar ( 20 ) 
DECLARE @YearNo int 

SET @YearNo = datepart ( yy , @StartDate ) 
SET @CurrentDate = datepart ( dd , @StartDate ) 
SET @currentMonth = datepart ( mm , @StartDate ) 
SET @CurrentDay = datepart ( dw , @StartDate ) 

INSERT @tbl ( Mon ) VALUES ( '' ) 
SET @CurrentRowID = @@Identity 

WHILE @currentMonth <= 12 
BEGIN 
    SET @monthName = datename ( m , @StartDate ) 
    INSERT @tbl ( Tue , Wed , Thu ) VALUES ( @monthName , '      xxx ' , convert ( varchar , @YearNo ) ) 
    SET @CurrentRowID = @@Identity 
    INSERT @tbl ( Sun , Mon , Tue , Wed , Thu , Fri , Sat ) VALUES ( '________' , '________' , '________' , '________' , '________' , '________' , '________' ) 
    INSERT @tbl ( Sun ) VALUES ( '' ) 
    SET @CurrentRowID = @@Identity 

    SET @TotalMonthDays = 
    CASE 
        WHEN @currentMonth IN ( 1 , 3 , 5 , 7 , 8 , 10 , 12 ) THEN 31 
        WHEN @currentMonth IN ( 4 , 6 , 9 , 11 ) THEN 30 
        WHEN @currentMonth = 2 AND @YearNo % 4 = 0 THEN 29 
        WHEN @currentMonth = 2 AND @YearNo % 4 <> 0 THEN 28 
    END 

    WHILE @CurrentDate <= @TotalMonthDays 
    BEGIN 
        IF @CurrentDay = 1 
        BEGIN 
            INSERT @tbl ( Sun ) VALUES ( '' ) 
            SET @CurrentRowID = @@Identity 
        END 
        IF @CurrentDay = 1 
        UPDATE @tbl SET Sun = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 
        ELSE IF @CurrentDay = 2 
        UPDATE @tbl SET Mon = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 
        ELSE IF @CurrentDay = 3 
        UPDATE @tbl SET Tue = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 
        ELSE IF @CurrentDay = 4 
        UPDATE @tbl SET wed = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 
        ELSE IF @CurrentDay = 5 
        UPDATE @tbl SET Thu = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 
        ELSE IF @CurrentDay = 6 
        UPDATE @tbl SET Fri = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 
        ELSE IF @CurrentDay = 7 
        UPDATE @tbl SET Sat = convert ( varchar ( 2 ) , @CurrentDate ) WHERE RowID = @CurrentRowID 

        SET @CurrentDate = @CurrentDate + 1 
        IF @CurrentDate = @TotalMonthDays + 1 
        BEGIN 
            SET @currentMonth = @currentMonth + 1 
            IF ( datepart ( DD , @StartDate ) > 1 ) 
            SET @StartDate = dateadd ( day , - ( datepart ( DD , @StartDate ) - 1 ) , @StartDate ) 
            SET @StartDate = dateadd ( month , 1 , @StartDate ) 
            SET @CurrentDay = datepart ( dw , @StartDate ) 
            INSERT @tbl ( Sun , Mon , Tue , Wed , Thu , Fri , Sat ) VALUES ( '************' , '************' , '************' , '************' , '************' , '************' , '************' ) 
        END 
        ELSE 
        SET @CurrentDay = ( @CurrentDay + 1 ) % 8 
        IF ( @CurrentDay = 0 ) 
        SET @CurrentDay = 1 
    END 
    SET @CurrentDate = 1 
END
SELECT * from @tbl