--------------------------------------------------------------------------------------
--This script uses the PrepareLogTables procedure and then SELECT statement to 
--analyze the SQL Server and SQL Server Agent log files.
--------------------------------------------------------------------------------------
USE sqlmaint
GO

--------------------------------------------------------------------------------------
--Populate tables
--------------------------------------------------------------------------------------
EXEC PrepareLogTables 2, 2



--------------------------------------------------------------------------------------
--SQL Server logs
--------------------------------------------------------------------------------------

--Size of SqlLogs table
EXEC sp_tableinfo 'SqlLogs' -- http://www.karaszi.com/SQLServer/util_sp_tableinfo.asp

--Timespan
SELECT MIN(LogDate) AS FirstEntryErrLog, MAX(LogDate) AS LastEntryErrLog FROM SqlLogs

--Work the WHERE clause
SELECT * FROM SqlLogs
WHERE LogDate > '2012-01-25'
--AND text NOT LIKE 'Starting up database %.'
--AND text NOT LIKE 'CHECKDB for database % finished without errors on %'
--AND text NOT LIKE 'DBCC CHECKDB (%'
--AND text NOT LIKE 'Error: 18456%'
--AND text NOT LIKE 'Login failed for user %'
--AND text NOT LIKE 'Error: 1205, Severity: 13, State:%'
--AND text NOT LIKE 'Transaction (Process ID %) was deadlocked on lock %resources with another process and has been chosen as the%'
--AND text NOT LIKE 'Setting database option %'
--AND text NOT LIKE 'SQL Trace%'
--AND text NOT LIKE 'Database backed up. Database: %'
--AND text NOT LIKE 'Database differential changes were backed up. Database: %'
--AND text NOT LIKE 'Log was backed up. Database:%'
--AND text NOT LIKE 'The database % is marked RESTORING and is in a state that does not allow recovery to be run.'
--AND text NOT LIKE 'Restore is complete on database %.  The database is now available.'
--AND text NOT LIKE 'Database was restored: Database: %'
--AND text NOT LIKE '% transactions rolled forward in database %. This is an informational message only. No user action is required.'
--AND text NOT LIKE '% transactions rolled back in database %. This is an informational message only. No user action is required.'
--AND text NOT LIKE 'Error: 3041, Severity: 16, State: %.'
--AND text NOT LIKE 'BACKUP failed to complete the command %. Check the backup application log for detailed messages.'
--AND text NOT LIKE 'Error: 18204, Severity: 16, State: 1.'
--AND text NOT LIKE '%: Backup device % failed to open. Operating system error %.'
--AND text NOT LIKE 'Error: 18210, Severity: 16, State: 1.'
--AND text NOT LIKE 'BackupIoRequest::ReportIoError: write failure on backup device %. Operating system error %'
--AND text NOT LIKE 'BackupIoRequest::ReportIoError: read failure on backup device %. Operating system error %'
--AND text NOT LIKE 'AppDomain % unloaded.'
--AND text NOT LIKE 'AppDomain % created.'
--AND text NOT LIKE 'Configuration option % changed from % to %. Run the RECONFIGURE statement to install.'
--AND text NOT LIKE 'I/O is frozen on database%'
--AND text NOT LIKE 'I/O was resumed on database%'
--AND text NOT LIKE 'Error: 1479, Severity: 16, State: 1.'
--AND text NOT LIKE 'The mirroring connection to%'
--AND text NOT LIKE 'Error: 1105, Severity: 17, State: 2.%'
--AND text NOT LIKE 'Could not allocate space for object%'
ORDER BY LogDate



--------------------------------------------------------------------------------------
--Agent logs
--------------------------------------------------------------------------------------

--Size of SqlLogs table
EXEC sp_tableinfo 'AgentLogs' -- http://www.karaszi.com/SQLServer/util_sp_tableinfo.asp

--Timespan
SELECT MIN(LogDate) AS FirstEntryAgentLog, MAX(LogDate) AS LastEntryAgentLog FROM AgentLogs

--Work the WHERE clause
SELECT * FROM AgentLogs
WHERE LogDate > '2012-01-25'
--AND teext NOT LIKE '%Unable to open the eventlog on forwarding server %'
--AND text NOT LIKE '%Request to run job ExecuteWebpayReplicationService%'
--AND text NOT LIKE '%SQLServer Error: 18456, Login failed for user %'
--AND text NOT LIKE '%SQLServer Error: 4060, Cannot open database %'
--AND text NOT LIKE 'Reloading agent settings'
ORDER BY LogDate

