USE TempDB
GO

--Turn on snapshot isolation
ALTER DATABASE TempDB 
SET ALLOW_SNAPSHOT_ISOLATION ON
GO


CREATE TABLE SomeData
(
	PK INT NOT NULL PRIMARY KEY,
	Data VARCHAR(200)
)
GO

INSERT SomeData
VALUES
(1, 'abcd')
GO


--Start a SNAPSHOT tran
--Read the data
SET TRANSACTION ISOLATION LEVEL SNAPSHOT

BEGIN TRAN

SELECT *
FROM SomeData
WHERE PK = 1
GO


--Now try to update the data
UPDATE SomeData
SET Data = 'defg'
WHERE PK = 1
GO


--Clean up
DROP TABLE SomeData
GO
